/*----- KEYSUP.C ------------------------------------------------------------*/
/* Key supplement routine, version 1.20 */

#pragma nonrec
#include <stdio.h>

VOID	prKSinfo();			/* header KEYSUP.C */

int	KSINST();			/* header KEYSUPM.MAC */
VOID	KSRMVL();
int	MMIniChk();
int	MMHPAL();

extern	 int	ksOffset;
extern	 int	HPADDR;

main (argc, argv)
int  argc;
char *argv[];
{
   puts("KEYSUP version 1.20\n");
   if (argc == 2) {
      char *c = argv[1]+1;
      *c = (islower(*c) ? *c-'a'+'A' : *c);
      if (strcmp(argv[1], "/I"))
	 if (strcmp(argv[1], "/R"))
	    prKSinfo();
	 else
	    if (ksOffset) {
	       KSRMVL();
	       puts("KEYSUP is removed.\n");
	    }
	    else
	       puts("KEYSUP is not installed what makes removing difficult.\n");
      else
	 if (ksOffset)
	    puts("KEYSUP has been installed already.\n");
	 else
	    if (MMIniChk() >= 0x0203)
	       if (HPADDR = MMHPAL()) {
		  argc = KSINST();	    /* use 'argc' as dummy variable */
		  printf("Installation completed, using heap memory: \
$%X-$%X (%d bytes)\n", HPADDR, HPADDR + argc -1, argc);
	       }
	       else
		  puts("Heap too small; adjust MEMMAN.\n");
	    else
	       puts("Memory Manager 2.30 (or higher) not available.\n");
   }
   else
      prKSinfo();
}

VOID prKSinfo() {
   puts("\
The MSX Maniac (pd) July 1993\n\
usage: keysup [/i|/r]\n\
     /i    installs key supplement routine\n\
     /r    removes key supplement routine\n");
}
